;;; Room map for standard strips domain.

(setq *X-DIM* 12)
(setq *Y-DIM* 10)
(setq *Z-DIM* 0)

(setq *ROOMS* (list	(list 	(make-location :room 'rril :x 9 :y 0 :z 0)
				(make-location :room 'rril :x 11 :y 3 :z 0))
			(list 	(make-location :room 'rclk :x 4 :y 0 :z 0)
				(make-location :room 'rclk :x 8 :y 3 :z 0))
			(list 	(make-location :room 'rpdp :x 2 :y 0 :z 0)
				(make-location :room 'rpdp :x 3 :y 3 :z 0))
			(list 	(make-location :room 'runi :x 0 :y 4 :z 0)
				(make-location :room 'runi :x 1 :y 9 :z 0))
			(list 	(make-location :room 'rmys :x 2 :y 4 :z 0)
				(make-location :room 'rmys :x 5 :y 9 :z 0))
			(list 	(make-location :room 'rhal :x 9 :y 4 :z 0)
				(make-location :room 'rhal :x 11 :y 9 :z 0))
			(list 	(make-location :room 'rram :x 6 :y 4 :z 0)
				(make-location :room 'rram :x 8 :y 9 :z 0))
	      ))

(setq *ROBOT-POS* (list
			(make-location :room 'rril :x 9 :y 3 :z 0)
			(make-location :room 'rhal :x 9 :y 9 :z 0)
			(make-location :room 'rram :x 6 :y 9 :z 0)
			(make-location :room 'rclk :x 4 :y 3 :z 0)
			(make-location :room 'rmys :x 2 :y 9 :z 0)
			(make-location :room 'rpdp :x 2 :y 3 :z 0)
			(make-location :room 'runi :x 0 :y 9 :z 0)
		  )
)

(setq *DOORS* 
	(list 
	   (make-door	:name 'dclkril
			:loc1 (make-location :room 'rril :x 9 :y 1  :z 0)
			:loc2 (make-location :room 'rclk :x 8 :y 1 :z 0))
	   (make-door	:name 'dmysclk
			:loc1 (make-location :room 'rmys :x 5 :y 4 :z 0)
			:loc2 (make-location :room 'rclk :x 5 :y 3 :z 0))
	   (make-door	:name 'dpdpclk
			:loc1 (make-location :room 'rclk :x 4 :y 1 :z 0)
			:loc2 (make-location :room 'rpdp :x 3 :y 1 :z 0))
	   (make-door	:name 'dmyspdp
			:loc1 (make-location :room 'rpdp :x 2 :y 3 :z 0)
			:loc2 (make-location :room 'rmys :x 2 :y 4 :z 0))
	   (make-door	:name 'dunimys
			:loc1 (make-location :room 'runi :x 1 :y 7 :z 0)
			:loc2 (make-location :room 'rmys :x 2 :y 7 :z 0))
	   (make-door	:name 'dmysram 
			:loc1 (make-location :room 'rmys :x 5 :y 7 :z 0)
			:loc2 (make-location :room 'rram :x 6 :y 7 :z 0))
	   (make-door	:name 'dramclk
			:loc1 (make-location :room 'rram :x 7 :y 4 :z 0)
			:loc2 (make-location :room 'rclk :x 7 :y 3 :z 0))
	   (make-door	:name 'dramhal
			:loc1 (make-location :room 'rram :x 8 :y 6 :z 0)
			:loc2 (make-location :room 'rhal :x 9 :y 6 :z 0))
	)
)
(setq *ROOM-MAP* (make-array (list *X-DIM* *Y-DIM*) :initial-element nil))

(initialize-room-map *ROOMS*)
